package Applid;

use Tk qw(DoOneEvent);
my $DEBUG=0;
my $port=6789;

#
# stop = 0:good,  1:stop! ;
# error = 0: good, 1: cannot connect, 2: bad fh 
#

sub new {
	my $proto=shift;
	my $url=shift;
        print "url: $url\n" if $DEBUG;

	my $class=ref($proto)||$proto;
	my $self={
	        fh=>-1, 
	        eof=>0, 
		stop=>0, 
		shipout=>[$url],
		body=>"",
		error=>0,
                sleepwait=>0,
	        };
	bless $self, $class;
	return $self;
}

sub closed {
        my $self=shift;
        print "\tFlags: eof($self->{eof}) error($self->{error}) abort($self->{stop})\n" if $DEBUG;
        return $self->{eof}||$self->{error}||$self->{stop}
}

sub stop {
        my $self=shift;
        $self->{stop}=1;        
}


sub eof {
        my $self=shift;        
        return $self->{eof}
}

sub error {
        my $self=shift;        
        return $self->{error}
}

sub sleepwait {
        my $self=shift;
        if(@_==0){return $self->{sleepwait}}
        $self->{sleepwait}=shift;
}        


sub url {
	my $self=shift;
	return $self->{shipout}->[0];
}

sub addline {
	my $self=shift;
	my $toadd=shift;
	my $shipout_ref=$self->{shipout};
	push @$shipout_ref,$toadd;
}

sub send_first {
	my $self=shift;
        my $p=shift;
        local *S;
	socket(S,2,1,6)&&
	connect(S,pack'Sna4x8',2,$port,(gethostbyname "localhost")[4])||
	    do{$self->{error}=1;print STDERR "Applid not running?";return};
	select(S); $|=1;select(STDOUT);
	my $shipout_ref=$self->{shipout};	
	$self->{fh}=*S;
        print "fileno: ",fileno(S),"\n" if  $DEBUG;
	my $to=shift @$shipout_ref;	
        my $send_request="<iml to=\"".$to."\">\n";
        print "$to>> $send_request\n" if $DEBUG;
	syswrite(S,$send_request,length($send_request));
        if(@$shipout_ref){
                select(undef,undef,undef,0.2);
                $send_request=join("\n",@$shipout_ref);
                #print "\t\t\<-------more\n $send_request\t\t------>\n";
                syswrite(S ,$send_request,length($send_request));
        }
        @{$shipout_ref}=();
}


sub send_again {
	my $self=shift;
	my $shipout_ref=$self->{shipout};
	if($self->{fh}==-1){$self->{error}=2;return}
	local *S= $self->{fh};	
	select(S); $|=1;select(STDOUT);
	my $send_request=join("\n",@$shipout_ref);
	syswrite(S ,$send_request,length($send_request));
        @{$self->{shipout}}=();
}

sub show_data {
	my $self=shift;
	my $shipout_ref=$self->{shipout_ref};
	return join("\n",@$shipout_ref);
}

sub body {
        my $self=shift;
        my $body=$self->{body};
        my ($parsable,$partial)=($body =~/^(.*)(<[^>]*)$/s);
        if($parsable eq "" && $partial eq ""){
                $self->{body}="";
                return $body;
        }else{
                $self->{body}=$partial;
                return $parsable;
        }
}

sub rawdata {
        my $self=shift;
        return $self->{body};
}


sub close_sock {
	my $self=shift;
	my $fh=$self->{fh};
	close($fh);
}

sub read_channel {
        my $self=shift;
        my $line="";
        if($line=_select_loop($self)){
                $self->{body}.=$line;
                #print "read_channel>> $line <<\n" if $DEBUG;
                return 1;
        }
        return 0;
}

# private
sub _select_loop {
        my $self=shift;
	my  $fh=$self->{fh};
        print "fileno: ",fileno($fh),"\n" if  $DEBUG;
        my $rin=""; my $eout=""; my $rout="";
        vec($rin,fileno($fh),1) = 1;        
        my $error=select(undef,undef,$eout=$rin,0);
	if (vec($eout,fileno($fh),1)) {
                $self->{error}=1;
                close($fh);
                return undef;
        }        
        if($self->{eof}){return undef}
        my $nact=select($rout=$rin,undef,undef,0);
        if ($nact==0) {return}
        if (vec($rout,fileno($fh),1)) {
#                select(undef,undef,undef,0.1);
                if (sysread($fh,$_,262144)>0) {
                        return $_;
                }else{
                        $self->{eof}=1;
                        return $_;
		}			
        }
}

# debug 
sub debug {$DEBUG=1}

#

1;
