package ImageState;

use  MIME::Base64;

my $DEBUG=0;
my $GIF=1;

sub new {
	my $proto=shift;
	my $url=shift;
        my $window=shift;
	my $class=ref($proto)||$proto;
	my $self={};
	bless $self, $class;        
	my $new_applid=Applid->new($url);
	$self->{url}=$url;
	$self->{applid}=$new_applid;
        $self->{schedule_state}=0;        
        $self->{run_state}=0;
       	$self->{image}="";
        $self->{window}=$window;
        return $self
}



sub set_schedule {
        my $self=shift;
        $self->{schedule_state}=1;                
}        

sub clear_schedule {
        my $self=shift;
        $self->{schedule_state}=0;
}

sub is_scheduled {
        my $self=shift;
        return $self->{schedule_state};
}


sub run {
        my $self=shift;
        my $ap=$self->{applid};        
        if($self->{run_state}==0){                
                $ap->send_first;
                $self->{run_state}=2;
                return
        }
        if($self->{run_state}==2){
                $ap->read_channel;
                return
        }
}        

sub stop {
        my $self=shift;
        print "Stop loading image $self\n" if $DEBUG;
        $self->{applid}->stop;        
}        

sub cleanup {
        my $self=shift;
        my $window=$self->{window};
        my $ap=$self->{applid};
        if($ap->eof){
                print "\t\t IMAGE  $self retrieved \n"  if $DEBUG;
                $self->{image}=$ap->rawdata;
                my ($txt, $canv, $imgref)=@$window;
		if($GIF){
                        my $img_enc=encode_base64($self->{image});
                        my $imgr=$txt->Photo(-data=>$img_enc);
                        $canv->itemconfigure($imgref,-image=>$imgr);
	        }else{
		        my $imgr=$txt->Bitmap(-data=>$self->{image});
			$canv->itemconfigure($imgref,-image=>$imgr);
		}
        }
	#print "Out of images ..\n";
        $self->{applid}->close_sock;
}

sub closed {
        my $self=shift;
        return $self->{applid}->closed;        
}


# debug 
sub debug {$DEBUG=1}

#


sub DESTROY {
        print "destroying ", shift, "\n";
        
}        

1;
