package Render; #not an Class; just a bunch of tag handlers  

my $DEBUG=0;
use ImageState;
use SoundState;
use sTable;
use sCode;
use Session;
use kItrans2utf;
use TamilItrans2utf;
use TamilUtf2Ta;
use hItrans2utf;
use TeluguItrans2utf;
use TeluguUtf2Ab;

my %begin_tag_handler = (
           "#txt#"   => \&txt_handler,
           "#title#" => \&title_text_handler,
		   "head"    =>  \&head_handler,		   
		   "iml"     => \&iml_handler,
		   "page"    => \&page_handler,
		   "tt"      => \&tt_handler,
		   "title"   => \&title_handler,
           "text"    => \&text_handler,
           "appl"    => \&appl_handler,
           "itemize" => \&itemize_handler,
           "item"    => \&item_handler,
           "br"      => \&br_handler,
           "table"   => \&table_handler,
           "tr"      => \&tr_handler,
           "td"      => \&td_handler,
           "image"   => \&image_handler,
           "input"   => \&input_handler,
		   "button"  => \&button_handler,
           "b"       => \&b_handler,
           "i"       => \&i_handler,
           "u"       => \&u_handler,
           "large"   => \&large_handler,                   
           "small"   => \&small_handler,
           "select"  => \&select_handler,
           "option"  => \&option_handler,
           "output"  => \&output_handler,
           "collect" => \&collect_handler,
           "update"  => \&update_handler,                   
           "turn"    => \&turn_handler,
           "audio"   => \&audio_handler,
           "svar"    => \&svar_handler,
           "attach"  => \&attach_handler,
           "lang"    => \&lang_handler	 
          );


my %end_tag_handler = (
           "#txt#"   => \&txt_ehandler,
           "#title#" => \&title_text_ehandler,                   
		   "head"    =>  \&head_ehandler,		   
		   "iml"     => \&iml_ehandler,
		   "page"    => \&page_ehandler,
		   "tt"      => \&tt_ehandler,    		   
		   "title"   => \&title_ehandler,
           "text"    => \&text_ehandler,
           "appl"    => \&appl_ehandler,
           "itemize" => \&itemize_ehandler,
           "item"    => \&item_ehandler,
           "br"      => \&br_ehandler,
           "table"   => \&table_ehandler,
           "tr"      => \&tr_ehandler,
           "td"      => \&td_ehandler,
           "image"   => \&image_ehandler,
           "input"   => \&input_ehandler,
		   "button"  => \&button_ehandler,		   
           "b"       => \&b_ehandler,
           "i"       => \&i_ehandler,
           "u"       => \&u_ehandler,
           "large"   => \&large_ehandler,
           "small"   => \&small_ehandler,
           "select"  => \&select_ehandler,
           "option"  => \&option_ehandler,
           "output"  => \&output_ehandler,
           "collect" => \&collect_ehandler,
           "update"  => \&update_ehandler,
           "turn"    => \&turn_ehandler,
           "audio"   => \&audio_ehandler,
           "svar"    => \&svar_ehandler,
		   "attach"  => \&attach_ehandler,
		   "lang"    => \&lang_ehandler	                    
                  );


my %image_handler = (
                  "draw"    => \&draw_on_canvas,
                  "create"  => \&create_canvas,
                  "src"     => \&image_src_canvas,
                  ); 


my %update_handler = (
                  "image"   => \&image_reconfig,
                  "text"    => \&text_reconfig,
                  "input"   => \&input_reconfig,                  
                  "audio"   => \&audio_reconfig,
                  "svar"    => \&svar_reconfig,
                  "page"    => \&page_reconfig
                  ); 

my %input_types = (text=>1, check=>1, radio=>1, hidden=>1);
# fonts 

my $normalf='-adobe-helvetica-medium-r-normal-12-*-*-*-p-*-iso8859-1';
my $boldf=  '-adobe-helvetica-bold-r-normal-12-*-*-*-p-*-iso8859-1';
my $italicf='-adobe-helvetica-medium-i-normal-12-*-*-*-p-*-iso8859-1';
my $largef= '-adobe-helvetica-medium-i-normal-18-*-*-*-p-*-iso8859-1';
my $smallf= '-adobe-helvetica-medium-i-normal-10-*-*-*-p-*-iso8859-1';
my $anchorf='-adobe-helvetica-bold-r-normal-12-*-*-*-p-*-iso8859-1';
my $ttf=    '-adobe-courier-medium-r-normal-12-*-*-*-m-*-iso8859-1';
#my $kannada='-freetype-kpnews-bold-r-normal--22-160-100-100-p-89-iso10646-1';
#my $hindi  ='-freetype-kpnews-bold-r-normal--22-160-100-100-p-89-iso10646-1';

%lang_table = (
hindi => '-freetype-naidunia-medium-r-normal--22-160-100-100-p-99-iso10646-1',
kannada => '-freetype-kpnews-bold-r-normal--22-160-100-100-p-89-iso10646-1',
tamil => '-tamil-tabakaram-medium-r-normal--12-120-75-75-p-92-iso8859-1',
telugu => '-freetype-abtelgu-medium-r-normal--14-100-100-100-p-87-iso10646-1'
);
    


#
#   render a new iml file onto a new canvas
#

sub begin_tag {
	my $state=shift;
	my $node = shift;
	my $tag = $node->tag;
	my $attr= $node->attr;
        my $bcoderef=$begin_tag_handler{$tag};
        $state->save_config;
	print "( $tag\n" if $DEBUG;
	$bcoderef->($state,$tag,$attr);
	if ($attr->{id}) {
	        $attr->{PAGENO}=$state->deck_handle->max;
                $attr->{TEXTWIDGET}=$state->write_to_widget;
		$state->id_hash($attr->{id},$node);
	}
	if($DEBUG){
        	for my $key (keys %$attr){
	        	print "* $key =|", $attr->{$key},"|\n";
        	}
	}
        $state->push_pstack($tag);        
}        

sub end_tag {
	my $state=shift;
	my $node = shift;
	my $tag = $node->tag;
	my $attr= $node->attr;
	my $ecoderef=$end_tag_handler{$tag};	
        $state->pop_pstack;      
	$ecoderef->($state,$tag,$attr);		
	print "/$tag )\n" if $DEBUG;
        $state->restore_config;
}        

sub display_page {
	my $state=shift;
	my $mark=$state->mark_deck;
        print "mark --------> $mark\n" if $DEBUG;
	my $todisplay=$state->deck_handle->random_access($mark);        
        On_display->set($todisplay);
        $state->page_attr($todisplay);
}


# BIG handlers  

sub iml_handler {
        my ($state, $tag, $attr)=@_;
        my $title=$state->title;
	my $header=UI->header;
	$header->configure(-text=>$title);
}


sub title_handler {
        my ($state, $tag, $attr)=@_;
	my $top=$state->pstack_handle->[0];
        if($top !~ /^head/){
                print "malformed title\n";                
	}
        $state->title("");
}

sub title_text_handler {
        my ($state, $tag, $attr)=@_;      
	my $text=$attr->{text};
        my $partial=$state->title;
        $state->title($partial.$text);
}

sub title_ehandler {
        my ($state, $tag, $attr)=@_;
        my $title=$state->title;
	my $header=UI->header;
        print "title |$title|\n" if $DEBUG;
	$header->configure(-text=>$title);
}


sub page_handler {
	my ($state, $tag, $attr)=@_;
	my $display= _new_text($attr);
        print "page> $display\n" if $DEBUG;
        $state->deck_handle->add($display);
        $state->map_display_attr($display, $attr);

        my $audio_format=$attr->{audioformat};
        my $voice=undef;
        if($audio_format eq "raw"){
                my $audio=$attr->{audio};                
                $voice=_get_audio_file($state, $audio);
                $attr->{AUDIO}=$voice;
        }
        if($audio_format eq "tts"){
                 my $speak=$attr->{speak};  
                 $voice=_create_tts($state, $speak);
                 $attr->{AUDIO}=$voice; 
        }

        if($audio_format eq "kannada"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_kannada($state, kItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_kannada($state, $speak);
                }
                $attr->{AUDIO}=$voice; 
        }

        if($audio_format eq "hindi"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_hindi($state, hItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_hindi($state, $speak);
                }
                $attr->{AUDIO}=$voice; 
        }

        if($audio_format eq "tamil"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_tamil($state, TamilItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_tamil($state, $speak);
                }
                $attr->{AUDIO}=$voice; 
        }

        if($audio_format eq "telugu"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_telugu($state, TeluguItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_telugu($state, $speak);
                }
                $attr->{AUDIO}=$voice; 
        }
        
#        if($attr->{audio}){
#                my $newaudio=_get_audio_file($state, $attr->{audio},1);
#                $attr->{AUDIO}=$newaudio;                
#        }        
}


sub page_ehandler {
	my ($state, $tag, $attr)=@_;
	my $no_pages=$state->deck_handle->max;
        my $curr_mark=$state->mark_deck;
        if($curr_mark == $no_pages){
                my $mark=$state->mark_deck;
                my $todisplay=$state->deck_handle->random_access($mark);
                On_display->set($todisplay);
        }
}



# icon/image handlers

sub appl_handler {
        my ($state, $tag, $attr)=@_;
	my $display=$state->current_widget;	
        my $baseurl=$state->base;
	my $icon=$attr->{icon};
        my $rel=$attr->{relief}||'raised';
        my $bd=($rel eq "flat")?0:2;
	if($icon !~ m%itp://%){# addr is not abs
	        $icon=$baseurl.$icon;
	}
	my $img=$display->Bitmap(-file => "images/default");
	my $canv=$display->Canvas(-width  =>64,
	                          -height =>64,
                                  -background => 'white',
                                  -relief=>$rel,
                                  -bd=>$bd,
                                  -highlightthickness => 0);	
        my $imgobj=$canv->createImage(0,0,-image => $img,-anchor=>'nw');
        my $b=UI->balloon;
        my $balloon=$attr->{balloon}||"no help!!";       
        #my $audio=$attr->{audio}||"audio/noaudio";
        my $audio_format=$attr->{audioformat};       
        my $voice=undef;
        
        if($audio_format  eq "raw"){
                my $audio=$attr->{audio};                
                $voice=_get_audio_file($state, $audio);
        }
        if($audio_format eq "tts"){
                 my $speak=$attr->{speak};                
                 $voice=_create_tts($state, $speak);
        }        
        if($audio_format eq "kannada"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_kannada($state, kItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_kannada($state, $speak);
                }
        }

        if($audio_format eq "hindi"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_hindi($state, hItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_hindi($state, $speak);
                }
        }

        if($audio_format eq "tamil"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_tamil($state, TamilItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_tamil($state, $speak);
                }
                $attr->{AUDIO}=$voice; 
        }

        if($audio_format eq "telugu"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_telugu($state, TeluguItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_telugu($state, $speak);
                }
                $attr->{AUDIO}=$voice; 
        }
        
        $b->attach($canv, -msg => $balloon);
	
        my $command=sub{call_applid($state,$attr, $voice)};                   
        $canv->Tk::bind("<1>",$command);
        _add_widget($state, $display, $canv);
        $attr->{WIDGET}=$canv;
        my $newimage=ImageState->new($icon,[$display, $canv,$imgobj]);
        $state->add_child($newimage);
        Schedule->job($newimage);
}

sub image_handler {
        my ($state, $tag, $attr)=@_;
        my $mode=$attr->{mode};
        print "\t\tmode>> |$mode| $attr->{$mode}\n" if $DEBUG;
        my $image_sub=$image_handler{$mode};
        $image_sub->($state,$tag,$attr);
}        


sub create_canvas {
        my ($state, $tag, $attr)=@_;
        my $display=$state->current_widget;
        my $bg=$attr->{bgcolor}||'white';
        my $rel=$attr->{relief}||'flat';
        my $canv=$display->Canvas(
                        -width=>$attr->{width},
                        -height=>$attr->{height},
                        -background => $bg,
                        -relief => $rel,
                        -highlightthickness => 0);
        $attr->{WIDGET}=$canv;
        print "canvas>> $canv\n" if $DEBUG;
        my $anchor=$attr->{anchor} || undef;
        my $command = sub {
                my $xcoord=$canv->pointerx-$canv->rootx;
                my $ycoord=$canv->pointery-$canv->rooty;
                report_canvas_coord($state, $attr,$xcoord, $ycoord);
        };
        # create balloon and audio hashes to be filled by other elemets of the
        # canvas; 
        my $balloon={};
        $attr->{BALLOON}=$balloon;
        my $audio={};
        $attr->{AUDIO}=$audio;
        $anchor  && $canv->Tk::bind("<1>", $command);
        my $b=UI->balloon;        
        $b->attach($canv,
                  -balloonposition => 'mouse',
                  -msg => $balloon,
                  );
        _add_widget($state, $display, $canv);
}


sub draw_on_canvas {
        my ($state, $tag, $attr)=@_;
        my $display=$state->current_widget;
        my $baseurl=$state->base;
        my $mode=$attr->{mode};        
        my $node=$state->id_hash($attr->{tagid});
        my $lattr=$node->attr;
        my $canv=$lattr->{WIDGET};
        my $coord=$attr->{coord};
        my $what=$attr->{$mode};
        my $opt=[];
        push @$opt, $what;
        push @$opt, split(/,/,$coord);
        my $v=undef;my $undef=undef;
        if($v=$attr->{fill}){push @$opt,  "-fill", $v}
        if($v=$attr->{width}){push @$opt, "-width", $v}
        if($v=$attr->{gravity}){push @$opt, "-anchor",$v}                
        if($v=$attr->{start}){push @$opt, "-start",$v}
        if($v=$attr->{extent}){push @$opt,"-extent",$v}
        if($v=$attr->{smooth}){push @$opt, "-smooth", $v}
        if($v=$attr->{text}){push @$opt,"-text", $v}
        if($v=$attr->{arrow}){push @$opt , "-arrow",$v}
        if($v=$attr->{dash}){push @$opt , "-dash",$v}            
        if($v=$attr->{color}){
                # you can do some pretty cool things like usemap
                # by declaring a polygonal region to have color "none" 
                if($v=~/none/){$v=$undef}
                push @$opt , "-outline",$v
        }
        
        if($v=$attr->{style}){push @$opt , "-style",$v}
        if($v=$attr->{stipple}){push @$opt , "-stipple",$v}
        if($v=$attr->{font}){push @$opt, "-font", $largef};
        my $tagid=$canv->create(@$opt);
        $lattr->{BALLOON}->{$tagid}=$attr->{balloon}||"no help!!";

        my $audio_format=$attr->{audioformat};       
        my $voice=undef;
        if($audio_format eq "raw"){
                my $audio=$attr->{audio};                
                $voice=_get_audio_file($state, $audio);
        }
        if($audio_format eq "tts"){
                 my $speak=$attr->{speak};                
                 $voice=_create_tts($state, $speak);
        }        
        if($audio_format eq "kannada"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_kannada($state, kItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_kannada($state, $speak);
                }
        }

        if($audio_format eq "hindi"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_hindi($state, hItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_hindi($state, $speak);
                }
        }

        if($audio_format eq "tamil"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_tamil($state, TamilItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_tamil($state, $speak);
                }
                $attr->{AUDIO}=$voice; 
        }
        
        if($audio_format eq "telugu"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_telugu($state, TeluguItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_telugu($state, $speak);
                }
                $attr->{AUDIO}=$voice; 
        }

        $attr->{VOICE}=$voice;        
        my $anchor=$attr->{anchor}||undef;        
	my $command=sub{call_applid($state,$attr,$attr->{VOICE})};
	$anchor && $canv->bind($tagid, '<1>' => $command);                
        
        $attr->{TAGID}=$tagid;
        $attr->{WIDGET}=$canv;
        print "draw>> $attr->{id} $canv $tagid\n" if $DEBUG;
}


sub image_src_canvas {
        my ($state, $tag, $attr)=@_;
        my $display=$state->current_widget;
        my $baseurl=$state->base;
        my $command=sub{call_applid($state,$attr)};        
        my $src=$attr->{src};

        if($src !~ m%itp://%){# addr is not abs
                $src=$baseurl.$src;
        }	        
        my $img=$display->Bitmap(-file => "images/default");
        my $node=$state->id_hash($attr->{tagid});
        my $lattr=$node->attr;
        my $canv=$lattr->{WIDGET};
        my $xoff=$attr->{xoff}||0;
        my $yoff=$attr->{yoff}||0;
        my $ianchor=$attr->{gravity}||'nw';
        my $anchor =$attr->{anchor} || undef;
        my $imgobj =$canv->createImage($xoff, $yoff,
                                   -image => $img,-anchor=>$ianchor,
                                   );
        $lattr->{BALLOON}->{$imgobj}=$attr->{balloon}||"no help!!";

        my $audio_format=$attr->{audioformat};
        my $voice=undef;
        
        if($audio_format  eq "raw"){
                my $audio=$attr->{audio};                
                $voice=_get_audio_file($state, $audio);
        }
        if($audio_format eq "tts"){
                 my $speak=$attr->{speak};                
                 $voice=_create_tts($state, $speak);
        }        
        if($audio_format eq "kannada"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_kannada($state, kItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_kannada($state, $speak);
                }
        }

        if($audio_format eq "hindi"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                     $voice=_create_hindi($state, hItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_hindi($state, $speak);
                }
        }

        if($audio_format eq "tamil"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_tamil($state, TamilItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_tamil($state, $speak);
                }
                $attr->{AUDIO}=$voice; 
        }

        if($audio_format eq "telugu"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_telugu($state, TeluguItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_telugu($state, $speak);
                }
                $attr->{AUDIO}=$voice; 
        }
        
        $attr->{VOICE}=$voice;
        $attr->{TAGID}=$imgobj;
        $attr->{WIDGET}=$canv;
        my $command=sub{call_applid($state,$attr,$attr->{VOICE})};
        ($anchor || $voice) && $canv->bind($imgobj, '<1>' => $command);                
        my $newimage=ImageState->new($src, [$display, $canv, $imgobj]);
        $state->add_child($newimage);
        Schedule->job($newimage);
}        

sub image_reconfig {
        my ($state, $tag, $attr)=@_;

        my $node=$state->id_hash($attr->{tagid});
        print "image_reconfig>> state: $state node: $node do: $attr->{do} tagid: $attr->{tagid}\n";# if $DEBUG;		
        my $lattr=$node->attr;
        my $canv=$lattr->{WIDGET};
        my $tagid=$lattr->{TAGID};

        if($attr->{do} eq "move"){
                my $xoff=$attr->{xoff}||0;
                my $yoff=$attr->{yoff}||0;
                print "MOVE $canv $tagid [$xoff $yoff]\n" if $DEBUG;
                $canv->move($tagid, $xoff, $yoff);
                return
        }
        if($attr->{do} eq "scale"){
                my $xorig=$attr->{xorig}||0;
                my $yorig=$attr->{yorig}||0;
                my $xscale=$attr->{xscale}||1;
                my $yscale=$attr->{yscale}||1;
                print "SCALE $canv $tagid....... \n" if DEBUG;
                $canv->scale($tagid, $xorig, $yorig, $xscale, $yscale);
                return                
        }
        if($attr->{do} eq "hide"){
                $canv->itemconfigure($tagid, -state=>'hidden');
                return
        }
        if($attr->{do} eq "unhide"){
                $canv->itemconfigure($tagid, -state=>'normal');
        }
        if($attr->{do} eq "write"){
                my $text=$attr->{text}||"";
                $canv->itemconfigure($tagid, -text=>$text);
        }
        if($attr->{do} eq "audio"){
                my $speak=$attr->{speak};
                $voice=_create_tts($state, $speak);
                print "voice $voice $speak\n";
                $lattr->{VOICE}=$voice;
                $voice->play;
        }        
}

# text handlers 

sub txt_handler {
	my ($state, $tag, $attr)=@_;
	my $display=$state->write_to_widget;
    my $tagno=$state->tagno;
	my $text=$attr->{text};        
        #$text=~s/&nbsp;/ /;
        #print "txt>> display: $display\n";
        #print "txt => |$text|\n";
    print "txt>>tagno $tagno\n" if $DEBUG;
        
    if($text=~/^$/){
        #        $display->insert('end'," ", $tagno);
        #        my $conf=$state->config;
        #        $display->tagConfigure($tagno,%$conf);                
        return
    }
	$display->insert('end',$text,$tagno);
	my $conf=$state->config;
	$display->tagConfigure($tagno,%$conf);	
}

sub text_handler {
	my ($state, $tag, $attr)=@_;
	if(exists $attr->{'justify'}){	
        	$state->config(-justify=>$attr->{'justify'});	
	}

    my $tagno=$state->begin_tagno;
    $attr->{TAGID}=$tagno;
	if (exists $attr->{'anchor'}) {
		$state->anchor(1);
		$state->config(-background=>'gray50');
		$state->config(-foreground=>'white');		
#        if($state->{langlevel}>0)
        if($state->langstack_top() eq "english") {
            $state->config(-font=>$anchorf);
        } else {
            $state->config(-font=>$state->{config}->{-font});
        }
	}
}

sub text_ehandler {
	my ($state, $tag, $attr)=@_;
        my $display=$state->write_to_widget;
        my $tagno=$state->end_tagno;
	if($state->anchor){# anchors cannot be nested
	        $display->tag('bind', $tagno,'<1>',
		        sub {call_applid($state,$attr)});
	        $state->anchor(0)
        }
}

sub br_handler {
	my ($state, $tag, $attr)=@_;
        my $display=$state->write_to_widget;
        #print "<br/>\n";
	$display->insert("end","\n");
}

sub b_handler {
        my ($state, $tag, $attr)=@_;
	$state->config(-font=>$boldf);
        $state->begin_tagno;        
}


sub b_ehandler {
        my ($state, $tag, $attr)=@_;
        $state->end_tagno;        
}

sub i_handler {
        my ($state, $tag, $attr)=@_;
	$state->config(-font=>$italicf);
        $state->begin_tagno;
        
}

sub i_ehandler {
        my ($state, $tag, $attr)=@_;
        $state->end_tagno;
}        


sub tt_handler{
        my ($state, $tag, $attr)=@_;
	$state->config(-font=>$ttf);
        $state->begin_tagno;
        #print "<tt>\n";
}        

sub tt_ehandler {
        my ($state, $tag, $attr)=@_;
        $state->end_tagno;        
}


sub large_handler {
        my ($state, $tag, $attr)=@_;
	$state->config(-font=>$largef);
        $state->begin_tagno;        
}

sub large_ehandler {
        my ($state, $tag, $attr)=@_;
        $state->end_tagno;        
}


sub small_handler {
        my ($state, $tag, $attr)=@_;
	$state->config(-font=>$smallf); 
        $state->begin_tagno;       
}

sub small_ehandler {
        my ($state, $tag, $attr)=@_;
        $state->end_tagno;        
}


sub u_handler {
        my ($state, $tag, $attr)=@_;
	$state->config(-underline=>1);
        $state->begin_tagno;        
}

sub u_ehandler {
        my ($state, $tag, $attr)=@_;
        $state->end_tagno;        
}

sub itemize_handler {
        my ($state, $tag, $attr)=@_;
	my $display=$state->write_to_widget;
	#$display->insert('end',"\n");
	my $type=$attr->{"style"}||"bullet";
	$state->save_istate;
	$state->itemattr($type);
	$state->item_counter(1);
}

sub itemize_ehandler {
        my ($state, $tag, $attr)=@_;
	my $display=$state->write_to_widget;
	$display->insert('end',"\n");
	$state->restore_istate;
}


sub item_handler {
        my ($state, $tag, $attr)=@_;
	my $display=$state->write_to_widget;
	$display->insert('end',"\n ");
	my $type=$state->itemattr;
	if($type=~/bullet/){
                $display->Bitmap("bullet",-file => "images/bullet");
                $display->imageCreate("end", -image => "bullet");
	}
	if($type=~/enum/){
	        $display->insert('end',$state->inc_item_counter.". ");
	}
}

sub text_reconfig {
        my ($state, $tag, $attr)=@_;
        my $node=$state->id_hash($attr->{tagid});
        my $lattr=$node->attr;
        my $textwg=$lattr->{TEXTWIDGET};
        my $tagid=$lattr->{TAGID};
        my $text=$attr->{text};
        $text=~s/&nbsp;/ /;
        print "text_reconfig>> $textwg $tagid do: $attr->{do}\n" if $DEBUG;
        my @ranges=$textwg->tagRanges($tagid);
        if(@ranges < 2){return}
        my $i1=shift @ranges;
        my $i2=shift @ranges;
        if($attr->{do} eq "replace"){
                print "Replace>>>>>>> i1=$i1 i2=$i2\n" if $DEBUG;
                $textwg->delete($i1, $i2);                
                $textwg->insert($i1,$text);
                return
        }
        if($attr->{do} eq "insert"){
                $textwg->insert($i1, $text);
        }                
        if($attr->{do} eq "append"){
                $textwg->insert($i2,$text);
        }        
}        



# language handler
sub lang_handler{
        my ($state, $tag, $attr)=@_;
        my $script=$attr->{script};
        my $langmode=$attr->{mode};
        if($langmode ne "itrans")   # For backward compatibility
        {
            $langmode="utf";
        }
        $state->config(-font=>$lang_table{$script});
#        $state->{langlevel}++;
        $state->push_langstack($script);
        $state->push_langmodestack($langmode);
        $state->begin_tagno;
}        

sub lang_ehandler {
        my ($state, $tag, $attr)=@_;
#        $state->{langlevel}--;
        $state->pop_langstack();
        $state->pop_langmodestack();
        $state->end_tagno;        
}


# audio 

sub audio_handler {
        my ($state, $tag, $attr)=@_;
	my $display=$state->current_widget;	
	my $img=$display->Bitmap(-file => "images/audio");
	my $canv=$display->Canvas(-width  =>13,
	                          -height =>13,
                                  -background => 'white',
                                  -highlightthickness => 0);
	my $imgobj=$canv->createImage(0,0,-image => $img,-anchor=>'nw');
        _add_widget($state, $display, $canv);

	# Modified code ......
	my $audio_format=$attr->{audioformat};
	my $voice;

        if($audio_format eq "raw"){
                my $audio=$attr->{audio};                
                $voice=_get_audio_file($state, $audio);
                $attr->{AUDIO}=$voice;
        }
        if($audio_format eq "tts"){
                my $speak=$attr->{speak};  
                $voice=_create_tts($state, $speak);
                $attr->{AUDIO}=$voice; 
        }
        if($audio_format eq "kannada"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                     $voice=_create_kannada($state, kItrans2utf::itrans2utf($speak));
                } else {
                     $voice=_create_kannada($state, $speak);
                }
                $attr->{AUDIO}=$voice; 
        }

        if($audio_format eq "hindi"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_hindi($state, hItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_hindi($state, $speak);
                }
                $attr->{AUDIO}=$voice; 
        }

        if($audio_format eq "tamil"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_tamil($state, TamilItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_tamil($state, $speak);
                }
                $attr->{AUDIO}=$voice; 
        }

        if($audio_format eq "telugu"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_telugu($state, TeluguItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_telugu($state, $speak);
                }
                $attr->{AUDIO}=$voice; 
        }
        
        
	# Modified code ...

        #my $newsound = _get_audio_file($state,$attr->{src});
        #my $command=sub{$newsound->play};
        my $command=sub{$voice->play};
        $canv->Tk::bind("<1>",$command);
}        



# table handlers 

sub table_handler {
        my ($state, $tag, $attr)=@_;
        my $display=$state->current_widget;
        my $newtable=$display->sTable();
        print "table>>$display  =>  $newtable\n"  if $DEBUG;
        _add_widget($state, $display, $newtable);
        $state->push_table($newtable);
}

sub tr_handler {
        my ($state, $tag, $attr)=@_;
	my $top=$state->pstack_handle->[0];
        if($top !~ /^table/){
                print "malformed table\n";
        }
}

sub td_handler {
        my ($state, $tag, $attr)=@_;
        my $top=$state->pstack_handle->[0];
        if($top !~ /^tr/){
                print "malformed table\n";
        }
        if(!$state->textwg){
                my $newtextwg=_new_textwg_cell($state,$attr);
                $state->textwg($newtextwg);
                $state->begin_tagno;
        }else{# empty garbage if any 
                my $textwg=$state->textwg;
                $textwg->delete('0.0','end');
        }
}

sub td_ehandler {
        my ($state, $tag, $attr)=@_;
        my ($table, $r, $c, $textwg, $widget)=$state->top_table;
        if(!defined $widget){# So we are in textwg 
                my $what=$textwg->get('0.0', 'end');chomp($what);
                my $w=length $what;
                print "width >> [$r, $c] => $w |$what|\n"  if $DEBUG;
                my $h= int($w/16)+1;
                if($w > 15){$w=15}
                if($r <0 || $c < 0){
                        _destroy($textwg);
                        last;
                }
                $textwg->configure(-width=>$w, -height=>$h, 
                                   -state=>'disabled');
                $table->put($r,$c,$textwg);
                $state->end_tagno;
                $state->textwg(undef);
        }else{
                $table->put($r,$c,$widget);
                $state->widget(undef);     
        }
        $state->table_inc_col;
}

sub tr_ehandler {
        my ($state, $tag, $attr)=@_;
        $state->table_reset_col;  
        $state->table_inc_row;
}

sub table_ehandler {
        my ($state, $tag, $attr)=@_;
        my $table=$state->current_widget;
        print "table_e>>table: $table\n" if $DEBUG;        
        $table->place;
        $state->pop_table;
}


# input/output handlers 

sub button_handler {
        my ($state, $tag, $attr)=@_;
	my $display=$state->current_widget;
	my $label=$attr->{label};
        my $bg=$attr->{bgcolor}||'white';
        my $fg=$attr->{fgcolor}||'black';     
        my $rel=$attr->{relief}||'raised';

#       my $b=UI->balloon;
#	my $balloon=$attr->{balloon}||"no help!";
#       #my $audio=$attr->{audio}||"audio/noaudio";
#       $b->attach($canv, -msg => $balloon);

        my $audio_format=$attr->{audioformat};
        my $voice=undef;
        
        if($audio_format  eq "raw"){
                my $audio=$attr->{audio};                
                $voice=_get_audio_file($state, $audio);
        }
        if($audio_format eq "tts"){
                my $speak=$attr->{speak};                
                $voice=_create_tts($state, $speak);
        }
        if($audio_format eq "kannada"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_kannada($state, kItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_kannada($state, $speak);
                }
        }

        if($audio_format eq "hindi"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_hindi($state, hItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_hindi($state, $speak);
                }
        }

        if($audio_format eq "tamil"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_tamil($state, TamilItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_tamil($state, $speak);
                }
                $attr->{AUDIO}=$voice; 
        }

        if($audio_format eq "telugu"){
                my $speak=$attr->{speak};  
                if($attr->{audiomode} eq "itrans") {
                    $voice=_create_telugu($state, TeluguItrans2utf::itrans2utf($speak));
                } else {
                    $voice=_create_telugu($state, $speak);
                }
                $attr->{AUDIO}=$voice; 
        }
        
        my $current_font = $normalf;
        $current_font = $state->{config}->{-font}
#                unless ($state->{langlevel}==0);
                unless ($state->langstack_top() eq "english");

#        if($state->{langlevel}>0)
        my $current_lang = $state->langstack_top();
        my $current_langmode = $state->langmodestack_top();
        if($current_lang eq "kannada") {
            if($current_langmode eq "itrans") {
                $label=kItrans2utf::itrans2utf($label);
            }
            $label=Utf2kp::utf2kp($label);
        }

        if($current_lang eq "tamil") {
            if($current_langmode eq "itrans") {
                $label=TamilItrans2utf::itrans2utf($label);
            }
            $label=TamilUtf2Ta::utf2ta($label);
        }

        if($current_lang eq "telugu") {
            if($current_langmode eq "itrans") {
                $label=TeluguItrans2utf::itrans2utf($label);
            }
            $label=TeluguUtf2Ab::utf2ab($label);
        }

        if($current_lang eq "hindi") {
            if($current_langmode eq "itrans") {
                $label=hItrans2utf::itrans2utf($label);
            }
            # FIXME Todo Utf2nd stuff
            $label=$label;
        }

        my $button=$display->Button(-text=>$label,
                                    -font=>$current_font,
                                    -background=>$bg,
                                    -foreground=>$fg,
                                    -relief=>$rel,
                             -command=>sub {call_applid($state,$attr,$voice)});
                        
        _add_widget($state, $display, $button);
}

sub input_handler {
        my ($state, $tag, $attr)=@_;
	my $display=$state->current_widget;
        my $var=$attr->{var};
	my $type=$attr->{type};
	my $value=$attr->{value}||"";
	my $var_ref=$state->var_ref($var,$attr);
	if($type=~/text/){
        	my $w=($attr->{'width'})?$attr->{'width'}:10;
	        my $h=($attr->{'height'})?$attr->{'height'}:1;
                my $current_font = $normalf;
                $current_font = $state->{config}->{-font}
                        unless ($state->langstack_top() eq "english");
#                        unless ($state->{langlevel}==0);
                my $entry=$display->Text(-width=>$w,-height=>$h,-font=>$current_font);
                if($value=~/^_(.*)/){# get data from svar 
                        my $var=$1;
                        my $magic=$attr->{magic};                    
                        print "s_var>> $var\n";
                        my $val=Session->query($var, $magic);
                        print "s_val>> $val\n";
                        $entry->insert('end',$val) if $val;
                }else{                
                        $entry->insert('end',$value);
                }
                _add_widget($state, $display, $entry);
                $attr->{WIDGET}=$entry;
                return
        }
        if($type=~/password/){
	        $$var_ref="";
        	my $w=($attr->{'width'})?$attr->{'width'}:8;	
                my $entry=$display->Entry(-show=>"*", 
		                          -width=>$w,
					  -textvariable=>$var_ref);
                _add_widget($state, $display, $entry);
                return                
        }	
	if($type=~/check/){
	        $$var_ref=0;
                my $display=$state->write_to_widget;
                my $entry=$display->Checkbutton(-background=>'white',
		                                -variable=>$var_ref,
		                                -highlightthickness=>0,
		                                -relief=>'flat');
                $display->windowCreate('end',-window => $entry);
                #_add_widget($state, $display, $entry);
                return                
        }
	if($type=~/radio/){
                my $display=$state->write_to_widget;                
                my $entry=$display->Radiobutton(-background=>'white',
		                                -variable=>$var_ref,
						-value=>$value,
				                -highlightthickness=>0,
						-relief=>'flat');
                $display->windowCreate('end',-window => $entry);
                #_add_widget($state, $display, $entry);
                return                
        }
	if($type=~/hidden/){
                $$var_ref=$value;
        }
}

sub select_handler {
        my ($state, $tag, $attr)=@_;
	my $var=$attr->{var};
        $state->empty_options;
        $attr->{type}="select";
        $attr->{hash}={};        
	$state->var_ref($var,$attr);

}


sub option_handler {
        my ($state, $tag, $attr)=@_;
        my $push_label=$attr->{label};
        my $push_value=$attr->{value};
        if(!defined $push_label){$push_label=$push_value}
        $state->push_options([$push_label,$push_value]);        
}

sub select_ehandler {
        my ($state, $tag, $attr)=@_;
	my $var=$attr->{var};
	my $display=$state->current_widget;
	my $opt=$state->options_handle;
	my $var_ref=$state->var_ref($var,$attr);
        my $optionmenu=$display->Optionmenu(-options =>$opt,
                                	     -command =>sub{$$var_ref=shift});
        _add_widget($state, $display, $optionmenu);
        $attr->{WIDGET}=$optionmenu;
        for(@$opt){
                my($l, $v)=@$_;
                $attr->{hash}->{$l}=$v;
        }
        my $firstopt=$opt->[0];
        $attr->{first}=$firstopt;
}

sub collect_handler {
        my ($state, $tag, $attr)=@_;       
        my $push_var=$attr->{varid};
        $state->push_options($push_var);
}

sub output_handler {
        my ($state, $tag, $attr)=@_;       
        $state->empty_options;
}

sub output_ehandler {
        my ($state, $tag, $attr)=@_;
        my $display=$state->current_widget;
        my $label=$attr->{label}||"Submit";
        my $opt=$state->options_handle;
        my $current_font=$normalf;
        $current_font=$state->{config}->{-font} 
            unless ($state->langstack_top() eq "english");
#            unless ($state->{langlevel}==0);

#        $label = Utf2kp::utf2kp($label) 
#            unless ($state->{langlevel}==0);

        my $current_lang = $state->langstack_top();
        my $current_langmode = $state->langmodestack_top();
        if($current_lang eq "kannada") {
            if($current_langmode eq "itrans") {
                $label=kItrans2utf::itrans2utf($label);
            }
            $label=Utf2kp::utf2kp($label);
        }

        if($current_lang eq "tamil") {
            if($current_langmode eq "itrans") {
                $label=TamilItrans2utf::itrans2utf($label);
            }
            $label=TamilUtf2Ta::utf2ta($label);
        }

        if($current_lang eq "telugu") {
            if($current_langmode eq "itrans") {
                $label=TeluguItrans2utf::itrans2utf($label);
            }
            $label=TeluguUtf2Ab::utf2ab($label);
        }

        if($current_lang eq "hindi") {
            if($current_langmode eq "itrans") {
                $label=hItrans2utf::itrans2utf($label);
            }
            # FIXME Todo Utf2nd stuff
            $label=$label;
        }

        my $out_button=$display->Button(-text=>$label, -font=>$current_font,
	                     -command=>sub{out_button($state,$attr,$opt)});
        _add_widget($state, $display, $out_button);
}

sub input_reconfig {
        my ($state, $tag, $attr)=@_;
        my $varid=$attr->{varid};
        my $newval=$attr->{value};
        my $var_ref=$state->var_out($varid);
        if(!defined $var_ref){print "Undefined $varid\n";return}
        my $lattr= $var_ref->[1];
        my $type=$lattr->{type};
        print "input_reconfig>> $type: $varid\n" if $DEBUG;
        my $widget=$lattr->{WIDGET};
        if($attr->{do} eq "set"){
                if($type=~/^text$/){
                        $widget->delete('0.0','end');
                        $widget->insert('0.0',$newval);
                        return
                }
                if($type=~/^check/){
                        $var_ref->[0]=1;
                        return
                }
                if($type=~/^select/){
                         my $label=$attr->{label};
                         my $value=$lattr->{hash}->{$label};
                         $widget->setOption($label, $value);
                         return
                }        
                if($input_types{$type}){
                        $var_ref->[0]=$newval;
                }
        }
        if($attr->{do} eq "reset"){
                if($type=~/^text$/){
                        $widget->delete('0.0','end');
                        return
                }
                if($type=~/^check/){
                        $var_ref->[0]=0;
                        return
                }
                if($type=~/^select/){
                         my $first=$lattr->{first};
                         my ($label, $value)=@$first;
                         $widget->setOption($label, $value);
                         return
                }                        
                if($input_types{$type}){
                        $var_ref->[0]=undef;
                }
        }
}

# Session_variables handler

sub svar_handler {
        my ($state, $tag, $attr)=@_;
        my $mode=$attr->{mode};
        my $passwd=$attr->{passwd};
        my $url=$state->url;
        if($url !~ m%^itp://localhost%){# bogus outsider!
                return
        }
        if($mode eq "init"){
                Session->init($passwd);
                return
        }
        if($mode eq "destroy"){
                Session->destroy($passwd);
                return
        }
        if($mode eq "populate"){
                Session->populate($attr->{string}, 
                                  $attr->{passwd});
                return
        }                
        if($mode eq "dump"){
                my $arg=Session->dump($passwd);
                $arg=_escape_string($arg);                
                my $len = length($arg);
		my $no_pages=$state->deck_handle->max;
		$state->mark_deck($no_pages+1); 
                my $conn= $state->applid_handle();
                my $arglist="<arg length=\"$len\">$arg</arg>";
		$conn->addline($arglist);
                if($state->closed){
                        print "Channel is closed!!\n";
                        return;
                }        
                $state->run_state(1);
                print "\t\t << Old channel >>\n" if $DEBUG;
                Schedule->job($state)                
        }        
}        

sub svar_reconfig {
        my ($state, $tag, $attr)=@_;
        my $varid=$attr->{varid};
        my $newval=$attr->{value};
        my $magic=$attr->{magic};
        if($attr->{do} eq "set"){
                Session->add($varid, $value, $magic);
                return
        }
        if($attr->{do} eq "reset"){
                Session->delete($varid, $magic);
                return
        }
}        


# update handler

sub update_handler {
        my ($state, $tag, $attr)=@_;
        my $class=$attr->{class};
        print "\t\tupdate>> |$class| $attr->{$class}\n" if $DEBUG;
        my $update_sub=$update_handler{$class};
        $update_sub->($state,$tag,$attr);
}        


# your turn! helps to de_schedule a job instead of spinning in a select loop

sub turn_handler {
        my $self=shift;
        print "In turn handler!!\n";
        $self->clear_schedule();
}


# attach handler : hack ... may not work 

sub attach_handler {
        my ($state, $tag, $attr)=@_;         
	print "In attach\n";
	my $base_url=$state->base;
	
	if($anchor !~ m%itp://%){# addr is not abs
	        $anchor=$base_url.$anchor;
        }	
	$state->morph($anchor);
	Schedule->job($state);
	print "out of  attach\n";	
}


#  create and destroy new  widgets ... 
sub _new_text {
        my $attr=shift;
        my $bg=$attr->{bgcolor}||'white';
        my $fg=$attr->{fgcolor}||'black';
	my $master=UI->display;
        #
	# new lines to create big imli 
	#
	
	my $textwg;
	if(UI->big){
      		$textwg=$master->Text( -width=>139,
				  -height=>50,
				  -cursor=>'left_ptr',
				  -background=>$bg,
                                  -foreground=>$fg,
				  -font=>$normalf,
				  -wrap=>'word');

	}else{	
		$textwg=$master->Text( -width=>33,
				  -height=>23,
				  -cursor=>'left_ptr',
				  -background=>$bg,
                                  -foreground=>$fg,
				  -font=>$normalf,
				  -wrap=>'word');
	}
	
	$textwg->place(-relx=>0,-rely=>0);
	$textwg->placeForget;
	return $textwg;
}

sub _new_textwg_cell {
        my $state=shift;
        my $attr=shift;
        my $bg=$attr->{bgcolor}||'white';
        my $fg=$attr->{fgcolor}||'black';     
        my $rel=$attr->{relief}||'sunken';
        my $nb=exists($attr->{border})?$attr->{border}:1;
        my $table=$state->current_widget;
        my $current_font=$normalf;
        $current_font=$state->{config}->{-font} 
                unless ($state->langstack_top() eq "english");
#                    unless ($state->{langlevel} == 0);

	my $textwg=$table->Text(  -height=>1,
				  -font=>$current_font,
				  -background=>$bg,
                                  -foreground=>$fg,
                                  -relief=>$rel,
                                  -highlightthickness=>$nb,
                                  -bd=>1,                                  
				  -wrap=>'word');
        print "new_textwg>> $table => $textwg\n" if $DEBUG;
        return $textwg;
}

sub _destroy {
	my $display=shift;
	$display->destroy;
}

sub _add_widget {
        my ($state, $widget, $new_widget)=@_;
        if($state->is_table){
                $state->widget($new_widget);
        }else{
                $widget->windowCreate('end',-window => $new_widget);
        }
}        

sub _get_audio_file {
        my ($state, $sound_src)=@_;
        my $baseurl=$state->base;        
	if($sound_src !~ m%itp://%){# addr is not abs
	        $sound_src=$baseurl.$sound_src;
	}
        my $newsound=SoundState->new($sound_src, "raw");
        $state->add_child($newsound);
        Schedule->job($newsound);
        return $newsound;
}        


sub _create_hindi {
        my ($state, $speak)=@_;
        my $newsound=SoundState->new($speak, "hindi");
        $state->add_child($newsound);
        return $newsound;
}        

sub _create_kannada {
        my ($state, $speak)=@_;
        my $newsound=SoundState->new($speak, "kannada");
        $state->add_child($newsound);
        return $newsound;
}        

sub _create_tamil {
        my ($state, $speak)=@_;
        my $newsound=SoundState->new($speak, "tamil");
        $state->add_child($newsound);
        return $newsound;
}        

sub _create_telugu {
        my ($state, $speak)=@_;
        my $newsound=SoundState->new($speak, "telugu");
        $state->add_child($newsound);
        return $newsound;
}        

sub _create_tts {
        my ($state, $speak)=@_;
        my $newsound=SoundState->new($speak, "tts");
        $state->add_child($newsound);
        return $newsound;
}        


sub _escape_string {
        my $str=shift;
        $str=~s/&/&amp/g;
        $str=~s/`/&apos/g;
        $str=~s/"/&quot/g;        
        $str=~s/</&lt/g;
        $str=~s/>/&gt/g;
        return $str
}        


# --- using old/creating new connections --------- 

sub out_button {
        my ($state,$attr,$opt)=@_;
	my $keyval={};
	for(@$opt){
                my ($var_val,$lattr)= @{$state->var_out($_)};
		my $type=$lattr->{type};
		print "$_ => $var_val, $lattr->{type}\n" if $DEBUG;
		if($type=~/^(text|svar)$/){
		        my $entry=$lattr->{WIDGET};
			my $out=$entry->get('0.0','end');
			chomp $out;
			$keyval->{$_}=$out;
			next
		}
		if($type=~/^check$/){
		        if($var_val){
			        $keyval->{$_}=$lattr->{value}
			}
			next
		}
		$keyval->{$_}=$var_val if (defined $var_val);
	}
        my $arg=sCode->encode($keyval,1);
        $arg=_escape_string($arg);
        my $len = length($arg);
        my $arglist="<arg length=\"$len\">$arg</arg>";        
	print $arglist,"\n" if $DEBUG;
	
	my $anchor=$attr->{anchor};
	if($anchor !~ /channel/){# new connection
	        print "new route\n" if $DEBUG;
                my $base_url=$state->base;
        	if($anchor !~ m%itp://%){# addr is not abs
	                $anchor=$base_url.$anchor;
        	}
                my $nstate=State->new($anchor);		
        	my $conn= $nstate->applid_handle();
		$conn->addline($arglist);
        	History->add($nstate);
                Schedule->job($nstate)
        }else{# old channel, try it ...         	        
		my $no_pages=$state->deck_handle->max;
		$state->mark_deck($no_pages+1); 
                my $conn= $state->applid_handle();
		$conn->addline($arglist);
                if($state->closed){
                        print "Channel is closed!!\n";
                        return;
                }        
                $state->run_state(1);
                print "\t\t << Old channel >>\n" if $DEBUG;
                Schedule->job($state)
	}
}


sub _out_arg {
        my ($state,$anchor,$opt)=@_;
        my $keyval={};
        my @kvp=split(/,/,$opt);
        for(@kvp){
                if(/^\s*\$(.*)/){
                        $_=$1; # delete dollar to get varid
                        my ($var_val,$lattr)= @{$state->var_out($_)};
                        my $type=$lattr->{type};
                        print "$_ => $var_val, $lattr->{type}\n" if $DEBUG;
                        if($type=~/^(text|svar)$/){
                                my $entry=$lattr->{WIDGET};
                                my $out=$entry->get('0.0','end');
                                chomp $out;
                                $keyval->{$_}=$out;
                                next
                        }
                        if($type=~/^check$/){
                                if($var_val){
                                        $keyval->{$_}=$lattr->{value}
                                }
                                next
                        }
                        $keyval->{$_}=$var_val if (defined $var_val);
                        next
                }
                my ($k,$v)=split(/=/,$_);
                $keyval->{$k}=$v;
        }
        my $arg=sCode->encode($keyval,1);
        $arg=_escape_string($arg);
        my $len = length($arg);
        my $arglist="<arg length=\"$len\">$arg</arg>";        
	print $arglist,"\n" if $DEBUG;
	if($anchor !~ /channel/){# new connection
	        print "new route\n" if $DEBUG;	
                my $base_url=$state->base;
        	if($anchor !~ m%itp://%){# addr is not abs
	                $anchor=$base_url.$anchor;
        	}
                my $nstate=State->new($anchor);		
        	my $conn= $nstate->applid_handle();
		$conn->addline($arglist);
        	History->add($nstate);
                Schedule->job($nstate)
        }else{# old channel, try it ...         
		my $no_pages=$state->deck_handle->max;
		$state->mark_deck($no_pages+1); 
                my $conn= $state->applid_handle();
		$conn->addline($arglist);
                if($state->closed){
                        print "Channel is closed!!\n";
                        return;
                }        
                $state->run_state(1);
                print "\t\t << Old channel >>\n" if $DEBUG;
                Schedule->job($state)
	}
}


sub report_canvas_coord {
        my ($state,$attr,$xcoord, $ycoord)=@_;
        my %h=(xcoord=>$xcoord, ycoord=>$ycoord);
        my $arg=sCode->encode(\%keyval);
        $arg=_escape_string($arg);
        my $len = length($arg);
        my $arglist="<arg length=\"$len\">$arg</arg>";        
	print $arglist if $DEBUG;
        
	my $anchor=$attr->{anchor};
	if($anchor !~ /channel/){# new connection
                my $base_url=$state->base;
        	if($anchor !~ m%itp://%){# addr is not abs
	                $anchor=$base_url.$anchor;
        	}        		
                my $nstate=State->new($anchor);		
        	my $conn= $nstate->applid_handle();
		$conn->addline($arglist);
        	History->add($nstate);
                Schedule->job($nstate)
        }else{# old channel, try it ... 
		my $no_pages=$state->deck_handle->max;
		$state->mark_deck($no_pages+1); 
                my $conn= $state->applid_handle();
		$conn->addline($arglist);
                if($state->closed){
                        print "Channel is closed!!\n";
                        return;
                }                
                $state->run_state(1);
                print "\t\t << Old channel >>\n";
                Schedule->job($state)
	}
}        

sub call_applid {
        my ($ostate,$attr,$voice)=@_;
        
        if(UI->audiostate){
                $voice && $voice->play;
                UI->toggleaudio();
                return
        }        
                        
        my $base_url=$ostate->base;
        my $anchor=$attr->{anchor};

        $anchor || return;  # In case there is only audio and no anchor
                            # return without doing anything

        my $page_id=undef;
        if($anchor =~ /^\s*_prev/){
                UI->button("left");
                return;
        
        }
        if($anchor =~ /^\s*_next/){
                UI->button("right");
                return;                        
        }
        if($anchor =~ /^\s*_reload/){
                UI->button("reload");
                return;                        
        }
        # dynamic update  ... 
        if($anchor =~ /^\s*_update\s*\((.*)\)/){
                my $line_to_parse="$1";
                my @list= split(/\s+/,$line_to_parse);
                my ($key,$val,$nattr);
                for (@list){
                        ($key, $val)=split /=/;
                        $val=~s/"//g;                        
                        $nattr->{$key}=$val;
                        print "$key =>$val\n";
                }
                update_handler($ostate, "",$nattr);
                return;
        }
        
	if($anchor =~ /^#(.*)/){# relative anchor 
		jump_to_page($ostate,[1,$1]);
		return
	}
	if($anchor =~ /(.*)#(.*)/){# go to page within 
	        $anchor=$1;
	        $page_id=$2;	
	}
        if($anchor =~ /(.*)\?(.*)/){# pass agruments to the program
                $anchor=$1;
                $arg=$2;
                #print "$anchor arg => |$2|\n";
                _out_arg($ostate,$anchor,$arg);
                return;
        }
	if($anchor !~ m%itp://%){# addr is not abs
	        $anchor=$base_url.$anchor;
	}        
	my $state=State->new($anchor);
	if(defined $page_id){	        
                $state->page_to_display([1,$page_id]);
	}
        History->add($state);
        Schedule->job($state);
}

sub jump_to_page {
        my ($state,$page_ref)=@_;
        my ($type, $page_no_or_id)=@$page_ref;
        my $page_no;
        if($type){
                my $node=$state->id_hash($page_no_or_id);
                my $lattr=$node->attr;
                $page_no=$lattr->{PAGENO};
        }else{
                $page_no=$page_no_or_id;
        }        
        my $todisplay=$state->deck_handle->random_access($page_no);
        #print "Jump!! |$page_no| -->> $todisplay\n";
        On_display->set($todisplay);
        $state->page_attr($todisplay);        
        return;
}

# debug 
sub debug {$DEBUG=1}

#

sub AUTOLOAD {
        #print "\t\t<-------- $AUTOLOAD\n";

}

#
1;
