package SoundState;

my $DEBUG=0;
my $SOUNDON=1;

sub new {
	my $proto=shift;
	my $url_or_text=shift;   # a terrible hack; 
        my $format=shift;
        
        
	my $class=ref($proto)||$proto;
	my $self={};
	bless $self, $class;        
        
        print "new SoundState: $self\n" if $DEBUG;
        $self->{audio}="";     
        $self->{speak}="";
        
        if($format eq "raw"){
                my $new_applid=Applid->new($url_or_text);
                $self->{applid}=$new_applid;                
                $self->{url}=$url_or_text
        }
        if($format eq "tts"){
                print "setting speak\n" if $DEBUG;
                $self->{speak}=$url_or_text;
        }
        if($format eq "kannada"){
                print "setting kannada speak\n" if $DEBUG;
                $self->{speak}=$url_or_text;
        }
        if($format eq "hindi"){
                print "setting hindi speak\n" if $DEBUG;
                $self->{speak}=$url_or_text;
        }
        if($format eq "tamil"){
                print "setting tamil speak\n" if $DEBUG;
                $self->{speak}=$url_or_text;
        }
        if($format eq "telugu"){
                print "setting telugu speak\n" if $DEBUG;
                $self->{speak}=$url_or_text;
        }
                
        $self->{schedule_state}=0;      
        $self->{run_state}=0;
        $self->{retrieved}=0;
        $self->{play_on_loading}=0;
        $self->{format}=$format;
        return $self
}



sub set_schedule {
        my $self=shift;
        $self->{schedule_state}=1;                
}        

sub clear_schedule {
        my $self=shift;
        $self->{schedule_state}=0;
}

sub is_scheduled {
        my $self=shift;
        return $self->{schedule_state};
}


sub run {
        my $self=shift;
        my $ap=$self->{applid};        
        if($self->{run_state}==0){                
                $ap->send_first;
                $self->{run_state}=2;
                return
        }
        if($self->{run_state}==2){
                $ap->read_channel;
                return
        }
}        

sub stop {
        my $self=shift;
        print "Stop loading sound $self\n" if $DEBUG;
        $self->{applid}->stop;        
}        

sub cleanup {
        my $self=shift;
        my $ap=$self->{applid};
        if($ap->eof){
                print "\t\t Audio  $self retrieved \n"  if $DEBUG;
                $self->{audio}=$ap->rawdata;
                $self->{retrieved}=1;                
                $self->{play_on_loading} && $self->play;
        }        
        $self->{applid}->close_sock;
}

sub closed {
        my $self=shift;
        return $self->{applid}->closed;        
}

sub play {
        my $self=shift;
        
        print ">> in audioplay\n" if $DEBUG;

        if($SOUNDON){
                if($self->{format} eq "raw"){
                        if(!$self->{retrieved}){
                                $self->{play_on_loading}=1; 
                                return
                        }                        
                        print ">> in raw\n" if $DEBUG;
                        open(A, ">/dev/dsp");
                        #select(A);
                        #$|=1;
                        #select(STDOUT);
                        print A $self->{audio};
                        close(A);
                        return
                }
                if($self->{format} eq "tts"){
                        print ">> in tts:: $self->{speak}\n" if $DEBUG;
                        socket(S,1,1,0);
                        my $phoneme_server="/tmp/synthsocket";
                        connect(S, pack('Sa50',1,$phoneme_server));
                        print S $self->{speak},"\n";
                        close(S);
                        return
               }
                if($self->{format} eq "kannada"){
                        print ">> in kannada:: $self->{speak}\n" if $DEBUG;
                        socket(S,1,1,0);
                        my $kannada_server="/tmp/kphonsocket";
                        connect(S, pack('Sa50',1,$kannada_server));
                        print S $self->{speak},"\n";
                        close(S);
                        return
               }
                if($self->{format} eq "hindi"){
                        print ">> in hindi:: $self->{speak}\n" if $DEBUG;
                        socket(S,1,1,0);
                        my $hindi_server="/tmp/hphonsocket";
                        connect(S, pack('Sa50',1,$hindi_server));
                        print S $self->{speak},"\n";
                        close(S);
                        return
               }
                if($self->{format} eq "tamil"){
                        print ">> in tamil:: $self->{speak}\n" if $DEBUG;
                        socket(S,1,1,0);
                        my $tamil_server="/tmp/tamilphonsocket";
                        connect(S, pack('Sa50',1,$tamil_server));
                        print S $self->{speak},"\n";
                        close(S);
                        return
               }
                if($self->{format} eq "telugu"){
                        print ">> in telugu:: $self->{speak}\n" if $DEBUG;
                        socket(S,1,1,0);
                        my $telugu_server="/tmp/teluguphonsocket";
                        connect(S, pack('Sa50',1,$telugu_server));
                        print S $self->{speak},"\n";
                        close(S);
                        return
               }
        }
}


sub showspeak { 
        $self=shift;
        print "speak str:", $self->{speak},"\n";


}

sub sound_on {$SOUNDON=1}
sub sound_off {$SOUNDON=0}

# debug 
sub debug {$DEBUG=1}

#


sub DESTROY {
        print "destroying ", shift, "\n";
        
} 

1;
