package State;

use Parse;
use Deck;
use Applid;

my $DEBUG=0;

#
# data str:  hash table with various information under  one "roof" 
#

sub new {
	my $proto=shift;
	my $url=shift;
	my $class=ref($proto)||$proto;
	my $self={};
	bless $self, $class;        
	my $new_applid=Applid->new($url);
	my $new_deck=Deck->new();
    my $new_parse=Parse->new($self);
	my $tag="tag0000";
	$self->{url}=$url;
	$self->{applid}=$new_applid;
	$self->{deck}=$new_deck;
    $self->{parse}=$new_parse;
	$self->{tagno}=$tag;
    $self->{tagstack}=[$tag];
    $self->{children}=[];
	$self->{id}={};
	$self->{config}={};
	$self->{stack}=[];
	$self->{item_type}="bullet";
	$self->{item_counter}=1;
	$self->{opt}=[];
	$self->{var}={};
	$self->{anchor}=0;
	$self->{title}=$url;
	$self->{pstack}=[];
	$self->{langmodestack}=[ "utf" ];
	$self->{langstack}=[ "english" ];
#    $self->{langlevel}=0;
	$self->{mark_deck}=1;
    $self->{schedule_state}=0;
    $self->{run_state}=0;
    $self->{page_to_display}=undef; #[type, page_id]
    $self->{table}=[];
    $self->{parse_error}=0;
    $self->{display_attr_hash}={};
    return $self
}

sub url {
    my $self=shift;
	return $self->{url}
}


# morph to be used along with attach... but not today! 
sub morph {
    my $self=shift;
	my $url=shift;
	$self->{url}=$url;
	$self->{applid}=$new_applid;	       
}


sub base {
    my $self=shift;
    my $base= $self->{url};
    my ($prefix,$suffix)=($base=~m%(.*/)(.*)%);
	#print "Base> $prefix, $suffix\n";
	return $prefix;	
}

sub write_to_widget {
    my $self=shift;
    my $writable=$self->{table}->[0]->{textwg};
    return $writable || $self->{deck}->current;
}        

sub current_widget {
    my $self=shift;
    my $toptable=$self->{table}->[0]->{table};
    return $toptable || $self->{deck}->current;
}

sub applid_handle {
	my $self=shift;
	return  $self->{applid};
}

sub closed {
    my $self=shift;
    return $self->{applid}->closed || $self->{parse_error};
}

sub render_handle {
	my $self=shift;
	return  $self->{render};
}

sub parse_handle {
	my $self=shift;	
	return  $self->{parse};
}

sub deck_handle {
	my $self=shift;
	return  $self->{deck};
}

sub mark_deck {
	my $self=shift;
	if(@_==0){return $self->{mark_deck}}
	$self->{mark_deck}=shift;	
}


sub id_hash {
	my $self=shift;
	my $id=shift;	
	if(@_==0){return $self->{id}->{$id}}
	my $val=shift;
	$self->{id}->{$id}=$val;
}

sub config {
	my $self=shift;
	if(@_==0){return $self->{config}}
	my $id=shift;
	my $val=shift;
	$self->{config}->{$id}=$val;
}

sub save_config {
    my $self=shift;
	my %new_conf=%{$self->{config}};
	push @{$self->{stack}},$self->{config};	
    $self->{config}=\%new_conf;
}

sub restore_config {
    my $self=shift;	
    $self->{config}=pop @{$self->{stack}};
}

sub tagno {
    my $self=shift;
	return $self->{tagstack}->[0] || undef;
}

sub begin_tagno {
    my $self=shift;
	++$self->{tagno};
    unshift @{$self->{tagstack}},$self->{tagno};
	return $self->{tagno}
}

sub end_tagno {
    my $self=shift;
    shift @{$self->{tagstack}} || undef;
}

sub itemattr {
    my $self=shift;
	if(@_==0){return $self->{item_type}}
    my $type=shift;
	$self->{item_type}=$type;        
}

sub item_counter {
    my $self=shift;
    if(@_==0){return $self->{item_counter}}
    my $count=shift;
	$self->{item_counter}=$count;       
}

sub inc_item_counter {
    my $self=shift;
	return $self->{item_counter}++;
}

sub save_istate {
    my $self=shift;
    my @old_istate=($self->{item_type},$self->{item_counter});
    push @{$self->{stack}}, \@old_istate;
}

sub restore_istate {
    my $self=shift;
	my $oldstate=pop @{$self->{stack}};
    ($self->{item_type},$self->{item_counter})=@$oldstate;
}

sub push_options {
    my $self=shift;
	my $val=shift;
	my $opt=$self->{opt};
	push @{$self->{opt}}, $val;
}

sub options_handle {
    my $self=shift;
	my $opt=$self->{opt};
    return $opt;
}

sub empty_options {
    my $self=shift;
    $self->{opt}=[];
}

sub var_ref {
    my $self=shift;
	my $varname=shift;
	my $attr=shift;
	if(!defined $self->{var}->{$varname}){	        
        	$self->{var}->{$varname}=[undef,$attr];
	}
	return \$self->{var}->{$varname}->[0];
}

sub var_out {
    my $self=shift;
	my $varname=shift;
 	return $self->{var}->{$varname}
}

sub anchor {
    my $self=shift;
	if(@_==0){return $self->{anchor}}
	$self->{anchor}=shift;
}

sub title {
    my $self=shift;
	if(@_==0){return $self->{title}}
	$self->{title}=shift;
}

sub push_pstack {
    my $self=shift;
	my $val=shift;
	my $ptr=$self->{pstack};
	unshift @{$self->{pstack}}, $val;
}

sub pop_pstack {
    my $self=shift;
	my $ptr=$self->{pstack};
	shift @{$self->{pstack}};
}

sub pstack_handle {
    my $self=shift;
	return $self->{pstack};
}

sub push_langmodestack {
    my $self=shift;
	my $val=shift;
	my $ptr=$self->{langmodestack};
	unshift @{$self->{langmodestack}}, $val;
}

sub pop_langmodestack {
    my $self=shift;
	my $ptr=$self->{langmodestack};
	shift @{$self->{langmodestack}};
}

sub langmodestack_handle {
    my $self=shift;
	return $self->{langmodestack};
}

sub langmodestack_top {
    my $self=shift;
	return $self->{langmodestack}[0];
}

sub push_langstack {
    my $self=shift;
	my $val=shift;
	my $ptr=$self->{langstack};
	unshift @{$self->{langstack}}, $val;
}

sub pop_langstack {
    my $self=shift;
	my $ptr=$self->{langstack};
	shift @{$self->{langstack}};
}

sub langstack_handle {
    my $self=shift;
	return $self->{langstack};
}

sub langstack_top {
    my $self=shift;
	return $self->{langstack}[0];
}

sub add_child {
    my $self=shift;
    my $child=shift;
    push @{$self->{children}},$child
}        

sub set_schedule {
    my $self=shift;
    $self->{schedule_state}=1;                
}        

sub clear_schedule {
    my $self=shift;
    $self->{schedule_state}=0;
}

sub is_scheduled {
    my $self=shift;
    return $self->{schedule_state};
}

sub run {
    my $self=shift;

    if($self->{run_state}==0){
            #print "runstate>>0\n";
            my $ap=$self->{applid};
            $ap->send_first;
            $self->{run_state}=2;
            return
    }
    if($self->{run_state}==1){
            #print "runstate>>1\n";                
            my $ap=$self->{applid};
            $ap->send_again;
            $self->{run_state}=2;
            return
    }
    if($self->{run_state}==2){
            #print "runstate>>2\n";                
            my $ap=$self->{applid};
            $ap->read_channel;
            my $p=$self->{parse};
            $p->parse($ap->body);
            return
    }
}        

sub stop {
        my $self=shift;
        $self->{applid}->stop;
        print "stopping ...\n";
        for my $child (@{$self->{children}}){
                $child->stop;           
        }                
}        


sub cleanup {
        my $self=shift;
        my $p=$self->{parse};
        if($self->{parse_error} || $self->{applid}->error){
                return;
        }
        eval{$p->done};
        undef $self->{parse};
        $self->{applid}->close_sock;
        if(defined $self->{page_to_display}){
                Render::jump_to_page($self,$self->{page_to_display});
        }else{
                # display the page to be shown 
                Render::display_page($self);
        }
}

sub run_state {
    my $self=shift;
	if(@_==0){return $self->{run_state}}
	$self->{run_state}=shift;
}

sub page_to_display {
    my $self=shift;
    if(@_==0){return $self->{page_to_display}}
	$self->{page_to_display}=shift;                
}

# table 

sub is_table {
    my $self = shift;
    return $self->{table}->[0]->{table}
}        


sub push_table {
    my ($self, $table)=@_;
    my $a= {table=>$table,
            textwg=>undef, 
            widget=>undef,
            c_row=>0, 
            c_col=>0
           };   
    unshift @{$self->{table}}, $a;
}


sub pop_table {
    my $self=shift;
    my $tref=$self->{table};
    shift @$tref;
}        

sub table_inc_row {
    my $self=shift;
    my $tref=$self->{table};
    if(@$tref){
            my $top=$tref->[0];
            ++$top->{c_row};                
    }
}

sub table_inc_col {
    my $self=shift;
    my $tref=$self->{table};
    if(@$tref){
            my $top=$tref->[0];
            ++$top->{c_col};
    }
}

sub table_reset_col {
    my $self=shift;
    my $tref=$self->{table};
    if(@$tref){
            my $top=$tref->[0];
            $top->{c_col}=0;
    }
}

sub top_table {
    my $self=shift;
    my $top=$self->{table}->[0];
    return ($top->{table}, $top->{c_row}, $top->{c_col}, $top->{textwg}, $top->{widget})
}        

sub textwg {
    my $self=shift;
    my $top=$self->{table}->[0];
    if(@_==0){return $top->{textwg}}
    $top->{textwg}=shift;
}

sub widget {
    my $self=shift;
    my $top=$self->{table}->[0];
    if(@_==0){return $top->{widget}}
    $top->{widget}=shift;
}

# parse error

sub set_parse_error {
    my $self=shift;
    return $self->{parse_error}        
}        

# timer ...

sub page_attr {# called by current page
    my $self=shift;
    my $disp=shift;
    my $cattr=$self->{display_attr_hash}->{$disp};
    print "page_attr>> $disp, $cattr\n" if $DEBUG;        
    if($cattr->{timer} > 0){
            print "page_attr>> $cattr->{timer}\n" if $DEBUG;
            my $timerid=$disp->after(1000*$cattr->{timer}, sub{Render::call_applid($self, $cattr)});
            Timer->set($timerid);
    }else{
            Timer->reset;                
    }
    if($cattr->{AUDIO}){
            print "Audio will be  played!\n" if $DEBUG;
            $cattr->{AUDIO}->play;                
    }
    print "out of page_attr\n" if $DEBUG;
}


# display attribute hash: required for timer

sub map_display_attr {
    my ($self, $disp, $attr)=@_;
    $self->{display_attr_hash}->{$disp}=$attr;
}        


# destroy!

sub DESTROY {
    print "destroying ", shift, "\n";
}        

1;
