package TamilUtf2Ta;
use Unicode::String qw(utf8 latin1 ucs2 uchr utf16);

# Basic vowels and consonants
%tatab = (
0x0b83 => 12,
0x0b85 => 0,
0x0b86 => 1,
0x0b87 => 2,
0x0b88 => 3,
0x0b89 => 4,
0x0b8a => 5,
0x0b8e => 6,
0x0b8f => 7,
0x0b90 => 8,
0x0b92 => 9,
0x0b93 => 10,
0x0b94 => 11,
0x0b95 => 13,
0x0b96 => 13,
0x0b97 => 13,
0x0b98 => 13,
0x0b99 => 26,
0x0b9a => 39,
0x0b9b => 39,
0x0b9c => 273,
0x0b9d => 273,
0x0b9e => 52,
0x0b9f => 65,
0x0ba0 => 65,
0x0ba1 => 65,
0x0ba2 => 65,
0x0ba3 => 78,
0x0ba4 => 91,
0x0ba5 => 91,
0x0ba6 => 91,
0x0ba7 => 91,
0x0ba8 => 104,
0x0ba9 => 234,
0x0baa => 117,
0x0bab => 117,
0x0bac => 117,
0x0bad => 117,
0x0bae => 130,
0x0baf => 143,
0x0bb0 => 156,
0x0bb1 => 121,
0x0bb2 => 169,
0x0bb3 => 208,
0x0bb4 => 195,
0x0bb5 => 182,
0x0bb7 => 247,
0x0bb8 => 260,
0x0bb9 => 286,
0x0bba => 299,
0x0bbb => 312,
0x0bbe => 1,
0x0bbf => 2,
0x0bc0 => 3,
0x0bc1 => 4,
0x0bc2 => 5,
0x0bc6 => 6,
0x0bc7 => 7,
0x0bc8 => 8,
0x0bca => 9,
0x0bcb => 10,
0x0bcc => 11,
0x0bcd => 12
);


@tab = ("","","","","","","","","","",
"","","",
"","","","","","","","","","","",
"","" ,
"","","","","","","","","","","",
"","",
"","","","","","","","","","","",
"","",
"","","","","","","","","","","",
"","",
"","","","","","","","","","","",
"","" ,
"","","","","","","","","","","",
"","" ,
"","","","","","","","","","","",
"","" ,
"","","","","","","","","","","","",
"",
"","","","","","","","","","","","","",
"","","","","","","","","","","","","" ,
"","","","","","","","","","","",
"","",
"","","","","","","","","","","",
"","",
"","","","","","","","","","","",
"","" ,
"","","","","","","","","","","",
"","" ,
"","","","","","","","","","","",
"","",
"","","","","","","","","","","",
"","" ,
"","","","","","","","","","","",
"","" ,
"","","","","","","","","","","",
"","" ,
"","","","","","","","","","","",
"","" ,
"","","","","","","","","","","",
"","",
"","","","","","","","","","","",
"","" ,
"","","","","","","","","","","",
"","" ,
"","","","","","","","","","",
"","","","");

sub utf2ta {
    my $utf_str = shift;
    my $ucs_str = Unicode::String->new($utf_str);
    my $ta_str = "";

    my $token_begin = 0;

    while ($token_begin < $ucs_str->length) 
    {
        if ($ucs_str->substr($token_begin,1)->ord == 0x20)
        {    
            $ta_str .= " "; 
            $token_begin++;
        }
        my $char =  $ucs_str->substr($token_begin,1)->ord;

        if ( ($char >= 0xb83 && $char <= 0x0b94) || $char == 0x0bbb ) { 
          $ta_str .= $tab[$tatab{$char}];
          $token_begin++;

        } 
        elsif ($char >= 0xb95 && $char <= 0x0bba) {
		my $char2 = $ucs_str->substr($token_begin+1,1)->ord;
		if ($char2 >= 0x0bbe && $char2 <= 0x0bcd) {
			$ta_str .= $tab[$tatab{$char}+$tatab{$char2}];
			$token_begin += 2;
		}
		else
		{
			$ta_str .= $tab[$tatab{$char}];
			$token_begin++;
		}

	}
	else 
        {
		$ta_str .= $ucs_str->substr($token_begin,1);
		$token_begin++;	 		

        }
    }
    return $ta_str;
}
